/****************************************************************************/
/*	LCD																	*/
/*	̃t@C̃^[QbǵAHdqʏAKI-H8-USB܂́A		*/
/*	AKI-H8-LAN(V[X)łB									*/
/*                                  Copyright (C) 2003- by hamayan			*/
/****************************************************************************/

#include	<stdio.h>
#include	<string.h>
#include	"3052s.h"
#include	"lcd.h"

void LcdWrite( int mode, char c );
static void LcdWrite4( char c );
static LCD	*lcd;

/*#define __CPU_CLOCK__	25000000*/	/*RpCIvVŎw肵Ȃ́ALɂĉB*/

/****************************************************************************/
/*	WAIT																*/
/*	1LOOP24VXeNbNB									*/
/*	AA\́A[v𑝂₷AŃ^C~O̒	*/
/*	sĉB															*/
/****************************************************************************/
static void wait40u( void )
{
#define		LOOP_COUNT_40	(40 * __CPU_CLOCK__ / 24 /1000000)
	volatile int i = LOOP_COUNT_40;

	for(; i > 0; i--){}
}

static void wait1u( void )
{
#define		LOOP_COUNT_1		(1 * __CPU_CLOCK__ / 24 /1000000)	/*1}CN?{ɂĂB*/
	volatile int i = LOOP_COUNT_1;

	for(; i > 0; i--){}
}

static void wait1000u( void )
{
#define		LOOP_COUNT_1000		(1000 * __CPU_CLOCK__ / 24 /1000000)
	volatile int i = LOOP_COUNT_1000;

	for(; i > 0; i--){}
}

static void dly_tsk( int tim )
{
	for( ; tim > 0; tim-- ) wait1000u();
}

/****************************************************************************/
/*																	*/
/*	LCD4bitoX[hɐݒ肷											*/
/****************************************************************************/
void LCDInit( void )
{
	lcd = (LCD *)&PB.DR.BYTE;		/*LCD𐧌䂷\̂̎̂*/
	/*\tgEGARESET*/
	lcd->RS = lcd->E = 0;			/*RS=E=0*/
	LcdWrite4( 0x03 );				/*3炵*/
	dly_tsk( 5 );					/*4.1msȏ҂*/
	LcdWrite4( 0x03 );				/*3炵*/
	dly_tsk( 1 );					/*1msȏ҂*/
	LcdWrite4( 0x03 );				/*3炵*/
	dly_tsk( 1 );					/*1msȏ҂*/
	LcdWrite4( 0x02 );				/*2炵*/
	/*ݒ*/
	FUNCTIONSET;
	FUNCTIONSET;
	DISPLAYOFF;
	ENTRYMODESET;
	CLEARDISPLAY;
	dly_tsk( 1 );					/*҂*/
	CURSORHOME;
	dly_tsk( 1 );					/*҂*/
	DISPLAYON;
}

/********************************************************************/
/*	4bitPʂłLCDݏ										*/
/*	cLCDɃR}hނf[^AA4bit̂ݗL		*/
/********************************************************************/
static void LcdWrite4( char c )
{
	lcd->E = 1;						/*Ebit𗧂Ă*/
	lcd->DATA = c;					/*f[^*/
	lcd->E = 0;						/*EbitƏ܂*/
}

/********************************************************************/
/*	LCDݏ													*/
/*	modeLCDɃR}hނf[^ނI			*/
/*	c͏ޕ												*/
/********************************************************************/
void LcdWrite( int mode, char c )
{

	if( mode == DATA_MODE ) lcd->RS = 1;		/*f[^[h*/
	else lcd->RS = 0;							/*R}h[h*/
	wait40u();
	LcdWrite4( c >> 4 );						/*4bit*/
	wait40u();
	LcdWrite4( c );								/*4bit*/
	wait40u();
}

/****************************************************************************/
/*	end of lcd.c															*/
/*																			*/
/*                                  Copyright (C) 2003- by hamayan			*/
/****************************************************************************/
